#include <iostream>
#include <stdio.h>
#include <Application.h>   // Be's BApplication class, necessary for any GUI stuff
#include <Window.h>  // Be's BWindow class
#include <Box.h>	   // Be's BBox class
#include <View.h>	   //Be's BView class
#include <string>
#include <Button.h>
#include <Roster.h>
#include <ColorControl.h>
#include <TextView.h>
#include <StringView.h>
#include <Alert.h>
#include "randgen.h"
const uint32 BRENT_DO_THIS = 'DoIt';
class BrentWindow : public BWindow
{
	public:
		BrentWindow();
		virtual void MessageReceived(BMessage * msg);
		virtual bool QuitRequested();
	private:
	BBox* brents_bbox;
	BView* parent_view;
	RandGen rred,rblue,rgreen;
};
//function implementation of BrentWindow() (contructor);
BrentWindow :: BrentWindow()
	: BWindow(BRect(50,50,200,200), "Misza's Window!", B_TITLED_WINDOW, B_NOT_RESIZABLE | B_NOT_ZOOMABLE)
{
	rgb_color bgcolor = ui_color(B_PANEL_BACKGROUND_COLOR);
	BRect b = Frame();
	b.OffsetTo(B_ORIGIN);
	parent_view = new BBox(b,"parent_view", B_FOLLOW_ALL, B_WILL_DRAW | B_FRAME_EVENTS | B_FULL_UPDATE_ON_RESIZE, B_PLAIN_BORDER);
	parent_view->SetViewColor(bgcolor);
	AddChild(parent_view);
	b.InsetBy(10,10);//BRect(10,10,135,115)
	brents_bbox = new BBox(b,"Misza's BBox", B_FOLLOW_ALL);
	brents_bbox->SetViewColor(bgcolor);//bgcolor
	brents_bbox->SetLabel("Misza's BBox");
	parent_view->AddChild(brents_bbox);
	
	BButton* button = new BButton(BRect(20,60,105,95),NULL,"PushMe", new BMessage(BRENT_DO_THIS),B_NOT_RESIZABLE);
	button->SetTarget(this);
	button->MakeDefault(true);
	brents_bbox->AddChild(button);
	
}
void BrentWindow :: MessageReceived(BMessage* msg)
{
	static int numPresses=1;

	switch(msg->what)
	{
		case BRENT_DO_THIS:
		{
			int red = rred.RandInt(0,255);
			int blue = rblue.RandInt(0,255);
			int green = rgreen.RandInt(0,255);
			
			if(red <= 127 && blue <= 127 && green <= 127)
			{parent_view->SetHighColor(255,255,255);
			brents_bbox->SetHighColor(255,255,255);
			}
			else{
			parent_view->SetHighColor(0,0,0);
			brents_bbox->SetHighColor(0,0,0);}
			char label[100];
			char alertme[50];
			sprintf(label, "Presses: %d", numPresses);
			if(numPresses % 10 == 0)
			{
			
			sprintf(alertme,"Congratulations! You've reached a milestone! %d Button Presses!", numPresses);
			BAlert* everyten = new BAlert("everyten", alertme, "Thanks!",NULL,NULL,B_WIDTH_AS_USUAL,B_IDEA_ALERT);
			everyten->Go();
			sprintf(label, "Presses: %d", numPresses);
			
			parent_view->SetLowColor(red,green,blue);
			parent_view->SetViewColor(red,green,blue);
			brents_bbox->SetLowColor(red,green,blue);
			brents_bbox->SetViewColor(red,green,blue);
			brents_bbox->SetLabel(label);
			brents_bbox->Invalidate();
			parent_view->Invalidate();
			numPresses++;
			break;
			}
			parent_view->SetLowColor(red,green,blue);
			parent_view->SetViewColor(red,green,blue);
			brents_bbox->SetLowColor(red,green,blue);
			brents_bbox->SetViewColor(red,green,blue);
			brents_bbox->SetLabel(label);
			brents_bbox->Invalidate();
			parent_view->Invalidate();
			numPresses++;
		}
		break;
				
		default:
		BWindow :: MessageReceived(msg);// all other types go to the parent class's method.
		break;
	}
}
// Called when the user clicks on the window's close box
bool BrentWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);// tell the application to quit too
	return true; // and indicate that it's okay for us to close
}

int main(int argc, char ** argv)
{
	BApplication app("application/x-vnd.Brent-bbox");//gotta have this
	//Create the window..
	BWindow* window = new BrentWindow();
	window->Show();	//shows up the window
	app.Run();
	return 0;
}
