#ifndef _STAT_WINDOW_H
#define _STAT_WINDOW_H

#include <OS.h> 
#include <iostream>
#include <stdio.h>
#include <Application.h>
#include <MessageRunner.h>
#include <String.h>
#include <StatusBar.h>
#include <View.h>
#include <Window.h>
#include <CheckBox.h>
#include <Alert.h>
const uint32 STARTME = 'Init';
const uint32 TURN_OFF_CPU_1 = 'off1';
const uint32 TURN_OFF_CPU_2 = 'off2';
const uint32 MISZA_BUTTON_PRESSED = 'Bpsd';
const int UPDATE_TIME_AMOUNT = 100000;
extern "C" int  _kset_cpu_state_(int cpu, int enabled);
extern "C" int  _kget_cpu_state_(int cpu);


class StatusWindow: public BWindow
{	//nothing much to see here :-)
	public:
		StatusWindow();
		virtual void MessageReceived(BMessage* msg);
		virtual bool QuitRequested();
		void UpdateCPUPercent();
	private:
		BStatusBar* ram_usage;
		BView* parent;
		BMessageRunner* update;
		BStatusBar* cpu2_usage;
		BStatusBar* cpu1_usage;
		double max,used,last_used;
		
		double last_active_cpu_time,last_active_cpu_time2;
		double delta_cpu, delta_cpu2;
		double last_system_time,delta_system;
		double percent,percent2;
		double lastpercent,lastpercent2;
		
		BCheckBox* CPU1;
		BCheckBox* CPU2;
};
#endif