#include <iostream>
#include <stdio.h>
#include <Application.h> 
#include <Window.h> 
#include <Bitmap.h>
#include <View.h>
#include <Rect.h>
#include <Point.h>
#include "Picture.h"

class PictureView : public BView
{
	public:
		PictureView(BBitmap* bitmap, BRect r);
		virtual void Draw(BRect drawRect);
	private:
		BBitmap* drawme;
};

PictureView::PictureView(BBitmap* bitmap, BRect r) : BView(r,"pictureview",B_FOLLOW_NONE,B_WILL_DRAW)
{
	drawme = bitmap;
}

void PictureView::Draw(BRect drawRect)
{
	
	DrawBitmap(drawme,BPoint(0,0));
	
}

class PictureWindow : public BWindow
{
	public:
		PictureWindow();
		virtual bool QuitRequested();
	
};
PictureWindow :: PictureWindow()
	: BWindow(BRect(50,50,319,175), "BeOS!!!!!!!!", B_TITLED_WINDOW, B_NOT_ZOOMABLE|B_NOT_RESIZABLE)
{
	BView* parent = new BView(Bounds(),"parent",B_FOLLOW_ALL,B_WILL_DRAW);
	AddChild(parent);
	parent->SetViewColor(223,0,50);
	
	BBitmap* image = new BBitmap(BRect(0,0,249,105),B_RGB32);
	image->SetBits(beos_logo,79500,0,B_RGB32);
	PictureView* BeOSView = new PictureView(image,BRect(10,10,259,115));
	BeOSView->SetDrawingMode(B_OP_OVER);
	parent->AddChild(BeOSView);
	
}
// Called when the user clicks on the window's close box
bool PictureWindow :: QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);// tell the application to quit too
	return true; // and indicate that it's okay for us to close
}

int main(int argc, char ** argv)
{
	BApplication app("application/x-vnd.misza-picturewindow");//gotta have this
	//Create the window..
	BWindow* window = new PictureWindow();
	window->Show();	//shows up the window
	app.Run();
	return 0;
}
