#include <iostream>
#include <stdio.h>
#include "app/Application.h"   // Be's BApplication class, necessary for any GUI stuff
#include "interface/Window.h"  // Be's BWindow class


//custom BWindow subclass
class BrentWindow : public BWindow
{
	public:
		BrentWindow();
		virtual bool QuitRequested();
		virtual void MessageReceived(BMessage* msg);
};
//function implementation of BrentWindow() (contructor);
BrentWindow :: BrentWindow()
	: BWindow(BRect(50,50,250,150), "Brent's Window!", B_TITLED_WINDOW, 0)
{
}
// Called when the user clicks on the window's close box
bool BrentWindow :: QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);// tell the application to quit too
	return true; // and indicate that it's okay for us to close
}
void BrentWindow::MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{	
		default:
			BWindow::MessageReceived(msg);
		break;
	}
}

int main(int argc, char ** argv)
{
	BApplication app("application/x-vnd.Brent-template");//gotta have this
	//Create the window..
	BWindow* window = new BrentWindow();
	window->Show();	//shows up the window
	app.Run();
	return 0;
}
